import React, { ComponentProps, Dispatch, ElementType, SetStateAction } from 'react';
export type FieldPropsBase = {
    fieldName?: string;
    type?: ElementType<any>;
    parentValue?: any;
    label?: React.ReactNode;
    description?: React.ReactNode;
    placeholder?: string;
    errorMessage?: string;
    fieldSchema?: object;
    schema?: object;
    passProps?: object;
    children?: React.ReactNode;
};
export type FieldProps<TValue = any, TTypeExtraProps = {}> = {
    value?: TValue;
    onChange?: Dispatch<SetStateAction<TValue>>;
} & FieldPropsBase & TTypeExtraProps;
export type FieldPropsWithBasicOnChange<TValue = any, TTypeExtraProps = {}> = {
    value?: TValue;
    onChange?: (value: TValue) => void;
} & FieldPropsBase & TTypeExtraProps;
export type FormFieldProps<TFieldType extends React.ElementType<any>> = TFieldType extends undefined ? {
    type: React.ElementType<any>;
    fieldName: string;
    errorMessage?: string;
} : {
    type: TFieldType;
    fieldName: string;
    errorMessage?: string;
} & FilteredFieldPropsFromComponent<TFieldType>;
export type FilteredFieldPropsFromComponent<TFieldType extends React.ElementType<any>> = Omit<ComponentProps<TFieldType>, 'fieldName' | 'type' | 'errorMessage' | 'parentValue' | 'fieldSchema' | 'schema' | 'value' | 'onChange' | 'errorMessage'>;
export declare const fieldPropsKeys: string[];
export type FormProps = Omit<React.HTMLProps<HTMLFormElement>, 'onChange'> & {
    children: React.ReactNode;
    state?: object;
    onChange?: Function | Dispatch<SetStateAction<any>>;
    errorMessages?: object;
    useFormTag?: boolean;
    onSubmit?: (value: object) => any;
};
export interface FormRef {
    submit: () => any;
    getValue: () => object;
    reset: () => void;
}
//# sourceMappingURL=types.d.ts.map